config/routes.rb
  ### R2. User routes
  resources :users, :only => [:new, :create] do
    collection do
      get "/forgot_password" => "password_resets#new", :as => :forgot_password
      post "/forgot_password" => "password_resets#generate_token", :as => :forgot_password_create
      get "/reset_password/:token" => "password_resets#prepare_reset", :as => :reset_password
      put "/reset_password/:token" => "password_resets#reset", :as => :do_reset_password
      get "/activate/:activation_code" => "user_activations#create"
      get "/pending_activation" => "user_activations#show", :as => :pending_activation
      get "/openid_build" => "open_id_users#new"
      post "/openid_create" => "open_id_users#create"
      get "/new" => "users#new"
      get "/view_state/repository/:id.:format" => "repository_view_state#show", :as => :repository_view_state
      get "/view_state/project/:id.:format" => "project_view_state#show", :as => :project_view_state
      get "/view_state.:format" => "user_view_state#show", :as => :view_state

      # Used to be we supported things like /users/~zmalltalker/mainline
      # No more, ~<user_name> is the canonical user URL namespace
      get "/*slug" => (redirect do |params, request|
                         request.fullpath.sub("users/", "~")
                       end), :slug => /.*/
    end
  end

  # `resources :users` can't do the ~<user> ids
  get "/~:id.keys" => "public_keys#index", :id => /[^\/]+/
  get "/~:id(.:format)" => "users#show", :as => "user", :id => /[^\/]+/
  get "/~:id/edit(.:format)" => "users#edit", :as => "edit_user", :id => /[^\/]+/
  put "/~:id(.:format)" => "users#update", :id => /[^\/]+/
  delete "/~:id(.:format)" => "users#destroy", :id => /[^\/]+/

  # Additional user actions
  scope "/~:id", :id => /[^\/]+/, :as => :user do
    get "/delete_current" => "users#destroy", :as => :delete_current
    delete "/avatar" => "avatars#destroy"
    get "/watchlist" => "user_watchlists#show", :as => :watchlist
    get "/feed" => "user_feeds#show", :as => :feed
    put "/update_password" => "passwords#update", :as => :update_password

    get "/aliases" => "users#edit", :defaults => { :tab => "email-aliases" }, :as => :edit_email_aliases
    get "/ssh-keys" => "users#edit", :defaults => { :tab => "ssh-keys" }, :as => :edit_ssh_keys
    get "/password" => "users#edit", :defaults => { :tab => "change-password" }, :as => :edit_password
    get "/favorites" => "users#edit", :defaults => { :tab => "manage-favorites" }, :as => :edit_favorites
  end

  # Nested user resources. This is in a separate scope because the
  # controllers expect params[:user_id] to contain the user, not
  # params[:id] as in the scope above
  scope "/~:user_id", :user_id => /[^\/]+/, :as => :user do
    resources :keys, :only => [:new, :create, :destroy, :index]

    resources :aliases do
      member do
        get :confirm
      end
    end

    get "/repositories" => "repositories#index"
    resource :license, :only => [:show, :edit, :update]
    match "/*slug" => "owner_redirections#show"
  end

  ### R3. Sessions
  resource :sessions
  get "/sessions" => "sessions#create", :as => :open_id_complete
  get "/login" => "sessions#new", :as => :login
  get "/login/http" => "sessions#http" # for Kerberos authentication
  get "/logout" => "sessions#destroy", :as => :logout

  ### R4. Groups
  resources :groups, :only => [:index, :new, :create]
  # `resource :groups` can't do the +<group> ids
  get "/+:id(.:format)" => "groups#show", :as => "group", :id => /[^\/]+/
  get "/+:id/edit(.:format)" => "groups#edit", :as => "edit_group", :id => /[^\/]+/
  put "/+:id(.:format)" => "groups#update", :id => /[^\/]+/
  delete "/+:id(.:format)" => "groups#destroy", :id => /[^\/]+/

  # Additional group actions
  scope "/+:id", :id => /[^\/]+/, :as => :group do
    delete "avatar" => "groups#avatar"
  end

  # Nested group resources. This is in a separate scope because the
  # controllers expect params[:group_id] to contain the group, not
  # params[:id] as in the scope above
  scope "/+:group_id", :id => /[^\/]+/, :as => :group do
    resources :memberships
    get "/repositories" => "repositories#index"
    match "/*slug" => "owner_redirections#show"
  end

  ### R5. Site-wide wiki
  get "/wiki/:site_id/config" => "site_wiki_pages#repository_config", :as => :site_wiki_git_access_connect
  get "/wiki/:site_id/writable_by" => "site_wiki_pages#writable_by", :as => :site_wiki_git_writable_by

  resources :site_wiki_pages, :path => "/wiki" do
    collection do
      get :git_access
    end

    member do
      get :history
    end
  end

  ### R6. Direct merge request access
  match "/merge_request_landing_page" => "merge_requests#oauth_return", :as => :merge_request_landing_page
  get "/merge_requests/:id" => "merge_requests#direct_access", :as => :merge_request_direct_access

  ### R7. Site controller, various loose pages
  get "/activities" => "site#public_timeline", :as => :activity
  get "/dashboard" => "site#dashboard", :as => :dashboard
  get "/my-activities" => "site#my_activities", :as => :dashboard_my_activities
  get "/about" => "site#about", :as => :about
  get "/about/:action" => "site#index", :as => :about_page
  get "/contact" => "site#contact", :as => :contact

  ### R8. Administration
  namespace :admin do
    get "/" => redirect { |params, request| "/admin/repositories" }

    resources :users, :only => [:index, :new, :create] do
      member do
        put :suspend
        put :flip_admin_status
        put :unsuspend
        put :reset_password
      end

      resources :keys, only: [:index, :new, :create, :destroy]
    end

    resources :projects, :only => [:show] do
      resource :oauth_settings, :only => [:show, :edit, :update]
    end

    resources :repositories, :only => [:index] do
      member do
        put :recreate
      end
    end

    resources :project_proposals, :only => [:index, :new, :create]
    post "/project_proposals/:id/reject" => "project_proposals#reject"
    post "/project_proposals/:id/approve" => "project_proposals#approve"
  end

  ### R9. API
  namespace :api do
    get ":project_id/:repository_id/log/graph(.:format)" => "graphs#show"
    get ":project_id/:repository_id/log/graph/*branch(.:format)" => "graphs#show"

    namespace :internal do
      get "/repo-config", to: "repository_configurations#show"
      get "/authenticate", to: "users#authenticate"
      get "/hooks/pre-receive", to: "hooks#pre_receive"
      post "/hooks/post-receive", to: "hooks#post_receive"
    end
  end

  ### R10. Events
  resources :events do
    member do
      get :commits
    end
  end

  ### R11. Additional logged in user resources
  resources :messages do
    collection do
      get :sent
      put :bulk_update
      get :all
      get :auto_complete_for_message_recipients
    end

    member do
      post :reply
      put :read
    end
  end

  resources :favorites, :only => [:index, :create, :update, :destroy]

  ### R12. Search
  get "/search", :controller => "searches", :action => "show", :as => :search

  ### R13. Auto-completion
  resources :user_auto_completions, :only => [:index]
  resources :group_auto_completions, :only => [:index]

  ### R14. Projects
  resources :projects, :only => [:index, :create]
  get "/:id/edit(.:format)" => "projects#edit"

  resources :projects, :path => "/" do
    member do
      put :preview
      get :edit_slug
      put :edit_slug
      get :confirm_delete
      get "/ownership/edit" => "project_ownerships#edit", :as => :transfer_ownership
      put "/ownership/edit" => "project_ownerships#update", :as => :transfer_ownership
    end

    resources :project_memberships, :only => [:index, :new, :create, :destroy]
    get "/community", :controller => :project_community, :action => :index
    get "/merge_requests", :controller => :project_merge_requests, :action => :index

    resources :pages do
      collection do
        get :git_access
      end

      member do
        get :history
      end
    end

    ### R14.2. Repositories

    # Listing repositories and creating new ones happens over
    # /<project>/repositories/, e.g:
    #   /gitorious/repositories/new
    resources :repositories, :only => [:index, :new, :create]

    # Browsing, editing and destroying existing repositories happens over
    # /<project>/<repository_name>/, e.g.:
    #   /gitorious/mainline
    #   /gitorious/mainline/edit
    resources(:repositories, {
                :path => "/",
                :only => [:show, :edit, :update, :destroy]
              }) do
      member do
        post "/create_clone" => "repository_clones#create"
        get "/clone" => "repository_clones#new"
        get "/search_clones" => "repository_clone_searches#show"
        get :committers
        get :confirm_delete
        get "/ownership/edit" => "repository_ownerships#edit", :as => :transfer_ownership
        put "/ownership/edit" => "repository_ownerships#update"
        get "/activities" => "repository_activities#index", :as => :activities
      end

      resources :comments, :controller => :repository_comments, :only => [:index]

      resources :services, :only => [:index, :destroy] do
        collection do
          post "/:service_type" => "services#create", :as => :create
          get "/:service_type" => "services#index"
        end
        resources :service_tests, :as => :tests, :only => [:create]
      end

      match "/community", :controller => :repository_community, :action => :index

      resources :merge_requests do
        collection do
          post :create
          post :commit_list
          post :target_branches
        end

        member do
          get :commit_status
          get :version
          get :terms_accepted
        end

        resources :comments, :controller => :merge_request_comments, :only => [:index, :create, :update]

        get "/diffs(/:version)" => "merge_request_versions#show", :as => :version

app/controllers/groups_controller.rb
# encoding: utf-8
#--
#   Copyright (C) 2012-2013 Gitorious AS
#   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#++

class GroupsController < ApplicationController
  before_filter :login_required, :except => [:index, :show]
  before_filter :find_group_and_ensure_group_adminship, :only => [:edit, :update, :avatar]
  before_filter :check_if_only_site_admins_can_create, :only => [:new, :create]
  renders_in_global_context

  def index
    begin
      groups, total_pages, page = paginated_groups
    rescue RangeError
      flash[:error] = "Page #{params[:page] || 1} does not exist"
      redirect_to(groups_path, :status => 307) and return
    end

    render("index", :locals => {
        :groups => groups,
        :page => page,
        :total_pages => total_pages
      })
  end

  def show
    group = Team.find_by_name!(params[:id])
    events = paginate(:action => "show", :id => params[:id]) do
      filter_paginated(params[:page], 30) do |page|
        Team.events(group, page)
      end
    end

    return if params.key?(:page) && events.length == 0

    render("show", :locals => {
        :group => group,
        :mainlines => filter(group.repositories.mainlines),
        :clones => filter(group.repositories.clones),
        :projects => filter(group.projects),
        :memberships => Team.memberships(group),
        :events => events
      })
  end

  def new
    render("new", :locals => { :group => Team.new_group })
  end

  def edit
    render("edit", :locals => { :group => @group })
  end

  def update
    Team.update_group(@group, params)
    flash[:success] = 'Team was updated'
    redirect_to(group_path(@group))
  rescue ActiveRecord::RecordInvalid
    render(:action => "edit", :locals => { :group => @group })
  end

  def create
    group = Team.create_group(params, current_user)
    group.save!
    flash[:success] = I18n.t("groups_controller.group_created")
    redirect_to group_path(group)
  rescue ActiveRecord::RecordInvalid, ActiveRecord::RecordNotFound
    render("new", :locals => { :group => group })
  end

  def destroy
    begin
      Team.destroy_group(params[:id], current_user)
      flash[:success] = "The team was deleted"
      redirect_to(groups_path)
    rescue Team::DestroyGroupError => e
      flash[:error] = e.message
      redirect_to(group_path(params[:id]))
    end
  end

  # DELETE avatar
  def avatar
    Team.delete_avatar(@group)
    flash[:success] = "The team image was deleted"
    redirect_to(group_path(@group))
  end

  protected
  def find_group_and_ensure_group_adminship
    @group = Team.find_by_name!(params[:id])
    unless admin?(current_user, @group)
      access_denied and return
    end
  end

  def check_if_only_site_admins_can_create
    if Gitorious.restrict_team_creation_to_site_admins?
      unless site_admin?(current_user)
        flash[:error] = "Only site administrators may create teams"
        redirect_to(:action => "index")
        return false
      end
    end
  end

  def paginated_groups
    page = (params[:page] || 1).to_i
    groups, pages = JustPaginate.paginate(page, 50, Team.count) do |range|
      Team.offset(range.first).limit(range.count).order_by_name
    end
    [groups, pages, page]
  end
end

app/helpers/groups_helper.rb
# encoding: utf-8
#--
#   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#++
module GroupsHelper
  def group_admin?(group,user)
    Team.group_admin?(group, user)
  end

  def restrict_team_creation_to_site_admins
    if logged_in?
      if Gitorious.restrict_team_creation_to_site_admins?
        yield if site_admin?(current_user)
      else
        yield
      end
    end
  end
end

app/views/groups/_form.html.erb
<%
  #--
  #   Copyright (C) 2013-2014 Gitorious AS
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
%>

<%= form.input(:name, :label => t("views.groups.team_name"), :disabled => group.persisted?, :hint => group.persisted? && 'Changing existing group name is not allowed') %>
<%= form.input(:description, :label => t("views.groups.description"), :input_html => { :class => 'input-xxlarge', :rows => 5 }) %>
<%= form.input(:avatar, :label => t("views.groups.avatar")) %>
<div class="control-group group-avatar">
 <label class="control-label">Current avatar</label>
 <div class="controls">
   <%= group_avatar(group, :size => :thumb, :class => 'pull-left') %>
   <% if group.avatar? %>
     <%= link_to "Delete", group_avatar_path(group), :method => :delete,
       :data => { :confirm => 'Are you sure?' },
       :class => 'delete-button' %>
   <% end %>
 </div>
</div>
<% if group.is_a?(LdapGroup) %>
  <%= form.input(:ldap_group_names, :as => :text, :hint => "Enter LDAP group RDNs (Relative DN), one per line "+
        "<strong>Note:</strong> entries should be relative to the LDAP base DN") %>
<% end %>

app/views/groups/_group.html.erb
<%
#--
#   Copyright (C) 2012-2013 Gitorious AS
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#++
%>
<li class="gts-listing-item">
  <% if group.avatar? %>
    <div class="gts-group-avatar">
      <%= group_avatar(group) %>
    </div>
  <% end %>
  <div class="gts-group-body">
    <h2>
      <%= link_to h(group.name), group_path(group.to_param) %>
    </h2>
    <%= pluralize group.members.count, t("views.groups.member_singular"), t("views.groups.member_plural") %>,
    <%= pluralize group.repositories.count, t("views.groups.repo_singular"), t("views.groups.repo_plural") %>
  </div>
</li>

app/views/groups/_header.html.erb
<%
  #--
  #   Copyright (C) 2012-2013 Gitorious AS
  #   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
%>

<%= site_header do %>
  <h2>
    <%= group_avatar(group) %>
    <%= link_to(group.name) %>
  </h2>
  <% if group.description? %>
    <div class="gts-markup">
      <%= render_markdown(group.description).html_safe %>
    </div>
  <% end %>
  <% if group_admin?(group, current_user) %>
    <%= render 'groups/show/admin_menu', :group => group, :active => active %>
  <% end %>
<% end %>

app/views/groups/_ldap_group_members.html.erb
<%
  #--
  #   Copyright (C) 2012-2013 Gitorious AS
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
  %>
<%= pull_box("LDAP Groups", :class => "repositories-box") do %>
  <table class="table">
    <% for group_name in group.ldap_group_names %>
      <tr><td><%= group_name %></td></tr>
    <% end %>
  </table>
<% end %>
<%= pull_box("Users", :class => "repositories-box") do %>
  <table class="table">
    <% for member in group.members %>
      <tr><td><%= link_to(member.login, member) %></td></tr>
    <% end %>
  </table>
<% end %>

app/views/groups/edit.html.erb
<%
  #--
  #   Copyright (C) 2012-2013 Gitorious AS
  #   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
%>

<% @title = group.name %>

<%= render('header', :active => true, :title => @title, :group => group) %>

<div class="container">
  <%= simple_form_for(group, :html => { :class => "form form-horizontal", :multipart => true }) do |f| %>
    <fieldset>
      <legend>Edit team</legend>
      <%= render('form', :form => f, :group => group) %>
      <div class="form-actions">
        <%= f.submit 'Save', :class => 'btn btn-primary' %>
      </div>
    </fieldset>
  <% end %>
</div>

app/views/groups/index.html.erb
<%
  #--
  #   Copyright (C) 2012-2013 Gitorious AS
  #   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
%>

<% @title = t("views.groups.teams") %>

<div class="container gts-body">
  <div class="gts-container">
    <div class="row-fluid">
      <div class="span8">
        <ul class="gts-listing">
          <%= render partial: 'group', collection: groups %>
        </ul>
        <%= raw JustPaginate.page_navigation(page, total_pages) { |n| groups_path(:page => n) } %>
      </div>
      <div class="span4">
        <% if current_user && (!Gitorious.restrict_team_creation_to_site_admins? || site_admin?(current_user)) %>
          <a class="btn btn-primary pull-right" href="<%= new_group_path %>">
            <i class="icon-plus-sign icon-white"></i>
            <%= t("views.groups.create_team") %>
          </a>
        <% end %>
      </div>
    </div>
  </div>
</div>

app/views/groups/new.html.erb
<%
  #--
  #   Copyright (C) 2012-2013 Gitorious AS
  #   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
  %>
<div class="gts-site-header">
  <div class="container">
    <div class="row">
      <h1 class="span"><%= @title = t("views.groups.create_team") %></h1>
    </div>
  </div>
</div>

<div class="container">
  <%= error_messages(group) -%>
  <%= simple_form_for(group, {
          :as => :group,
          :url => groups_path,
          :html => { :class => "form-horizontal", :multipart => true }
        }) do |f| -%>
    <fieldset>
      <%= render(:partial => "form", :locals => { :form => f, :group => group }) -%>
      <div class="form-actions">
        <button class="btn btn-primary" type="submit"><%= t("views.groups.create_team_submit") %></button>
      </div>
    </fieldset>
  <% end %>
</div>

app/views/groups/show.html.erb
<%
  #--
  #   Copyright (C) 2012-2013 Gitorious AS
  #   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
%>

<% @title = group.name %>
<%= render('header', :active => true, :title => @title, :group => group) %>

<div class="container">
  <div class="row-fluid">
    <div class="span8">
      <%= render 'events/events', :events => events %>
    </div>
    <div class="span4">
      <%= render("groups/show/memberships", :group => group, :memberships => memberships) %>
      <%= render("projects/projects", {
            :projects => projects,
            :hint => "This team does not yet have any projects.",
            :heading => "Projects"
          }) %>
      <%= render("repositories/repositories", {
            :repositories => mainlines,
            :hint => "This team does not yet have any repositories.",
            :heading => "Repositories"
          }) %>
      <%= render("repositories/repositories", {
            :repositories => clones,
            :hint => "This team does not yet have any repository clones.",
            :heading => "Clones"
          }) %>
    </div>
  </div>
</div>